<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Models;

use Carbon\Carbon;
use App\Http\Base\BaseModel;

class LaporanpelumasModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "laporanpelumas";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "laporanpelumas";

    /**
     * primary key from table remember eloquent doesnt support composite primary key
     */
    protected $primaryKey = "id";
    /**
     * check the incrementing boolean if the incrementing from database is false then the value is false by default
     */
    // public $incrementing = false;
    /**
     * fillable property for eloquent attribute cast
     */
    protected $fillable = [
        "id", "tahun", "bulan", "bulan_text", "voyage_id", "voyage_name",
        "voyage_from", "voyage_to", "jarak_tempuh",
        "tipe", "keterangan", "is_locked", "kapalId", "voyage_num", "date_created"
    ];
    /**
     * Creating raw object from table that, this purpose for making you easier for remembering all attribute
     */


    /**
     * paging for default paging purpose
     * if you want to add new paging property you have to add the property in this array
     * you have to add the relation value
     * remember this is not suported casting value you have to handle by your self
     */
    protected $aliasPaging = [
        "id" => "laporanpelumas.id",
        "voyage_name" => "laporanpelumas.voyage_name",
        "bulan" => "laporanpelumas.bulan",
        "tahun" => "laporanpelumas.tahun"
    ];

    public function joinRelationVoyageKode($alias = "voyages")
    {
        $this->getQuery()->join("voyages as $alias", "$alias.voyageKode", "=", "laporanpelumas.voyage_id");
        return $this;
    }

    public function joinRelationPelumasDetails($alias = "laporanpelumasdetails")
    {
        $this->getQuery()->join("laporanpelumas_details as $alias", "$alias.reportId", "=", "laporanpelumas.id");
        return $this;
    }

    public static function cronjobPelumas()
    {
        $sysParams = (new SystemparameterModel())->getQuery()->where("variableName", "=", "PELNIBBMPELUMAS")->first();
        $categoryPelumas = explode(";", $sysParams->variableValue)[1];
        $pelumasItems = (new ItemModel())->getQuery()
            ->where("enabled_flex", "=", "Y")
            ->where("type_id", "=", $categoryPelumas)
            ->get();

        // PER MONTH
        $month = date("n") - 1;
        for ($i = $month; $i >= 0; $i--) {
            if ($i == 0) {
                $bulan = 12;
                $tahun = date("Y") - 1;
            } else {
                $bulan = $i;
                $tahun = date("Y");
            }
            $lastYear = date("Y") - 1;

            $pelumasMonth = (new LaporanpelumasModel())->getQuery()->where("tahun", "=", $tahun)
                ->where("bulan", "=", $bulan)
                ->first();
            if ($pelumasMonth) {
                // ROW DATA LAPORAN UNTUK BLN INI SUDAH ADA
            } else {
                // KL BLM ADA CREATE BARU
                $awalBulan = $tahun . "-" . $bulan . "-01";
                $input = [
                    "tahun"         => $tahun,
                    "bulan"         => date("n", strtotime($awalBulan)),
                    "bulan_text"    => date("F", strtotime($awalBulan)),
                    "tipe"          => "MONTH",
                    "is_locked"     => "N",
                    "kapalId"       => $GLOBALS["env"]["KAPAL_ID"],
                    "voyage_from"   => $awalBulan,
                    "voyage_to"     => date("Y-m-t", strtotime($awalBulan))
                ];
                $model = new self();
                $model->fill($input);
                $model->save();
                $reportId = $model->id;

                foreach ($pelumasItems as $pelumasItem) {
                    // KL BLM ADA CREATE BARU
                    $input = [
                        "reportId"      => $reportId,
                        "itemId"        => $pelumasItem->id,
                        "saldo_awal"    => 0,
                        "pemakaian"     => 0,
                        "saldo_akhir"   => 0,
                        "namaItem"      => $pelumasItem->namaItem,
                        "deskripsi"     => $pelumasItem->deskripsi,
                        "tahun"         => $tahun,
                        "bulan"         => date("n", strtotime($awalBulan)),
                    ];
                    $model = new LaporanpelumasdetailsModel();
                    $model->fill($input);
                    $model->save();
                }
            }
        }

        // PER VOYAGE
        $voyages = (new VoyageModel())->getQuery()->where("tahun", "=", date("Y"))
            ->where("kapalId", "=", $GLOBALS["env"]["KAPAL_ID"])
            ->where("call_num", "=", 1)
            ->where("voyage_to", "<", date("Y-m-d"))
            ->get();


        $voyageLastYear = (new VoyageModel())->getQuery()
            ->where("kapalId", "=", $GLOBALS["env"]["KAPAL_ID"])
            ->where("call_num", "=", 1)
            ->where("tahun", "=", $lastYear)
            ->orderBy("voyage_num", "desc")
            ->first();

        if ($voyageLastYear) {
            $voyages[] = $voyageLastYear;
        }


        foreach ($voyages as $rows) {
            if (isset($rows->tahun) and isset($rows->voyageKode)) {
                $pelumasVoyage = (new LaporanpelumasModel())->getQuery()->where("tahun", "=", $rows->tahun)
                    ->where("voyage_id", "=", $rows->voyageKode)
                    ->first();
                if ($pelumasVoyage) {
                    // ROW DATA LAPORAN UNTUK BLN INI SUDAH ADA
                } else {
                    // KL BLM ADA CREATE BARU
                    $input = [
                        "tahun"         => $rows->tahun,
                        "bulan"         => date("n", strtotime($rows->voyage_from)),
                        "bulan_text"    => date("F", strtotime($rows->voyage_from)),
                        "voyage_id"     => $rows->voyageKode,
                        "voyage_name"   => $rows->voyageName,
                        "voyage_num"    => $rows->voyage_num,
                        "voyage_from"   => date("Y-m-d", strtotime($rows->voyage_from)),
                        "voyage_to"     => date("Y-m-d", strtotime($rows->voyage_to)),
                        "tipe"          => "VOYAGE",
                        "is_locked"     => "N",
                        "kapalId"       => $GLOBALS["env"]["KAPAL_ID"]
                    ];
                    $model = new self();
                    $model->fill($input);
                    $model->save();
                    $reportId = $model->id;

                    foreach ($pelumasItems as $pelumasItem) {
                        // KL BLM ADA CREATE BARU
                        $input = [
                            "reportId"      => $reportId,
                            "itemId"        => $pelumasItem->id,
                            "saldo_awal"    => 0,
                            "pemakaian"     => 0,
                            "saldo_akhir"   => 0,
                            "namaItem"      => $pelumasItem->namaItem,
                            "deskripsi"     => $pelumasItem->deskripsi,
                        ];
                        $model = new LaporanpelumasdetailsModel();
                        $model->fill($input);
                        $model->save();
                    }
                }
            }
        }
    }
}
